
C----------------------------------------------------------------------C
C                                                                      C
C   Global variables common to Metropolis and Swendsen-Wang programs.  C
C                                                                      C
C----------------------------------------------------------------------C

      IMPLICIT NONE 

      INTEGER dim, dimm1
      REAL*4  fdim, volume
      PARAMETER (dim  = 128)
      PARAMETER (fdim = 128.0)
      PARAMETER (dimm1 = dim - 1)
      PARAMETER (volume = fdim*fdim)

      REAL*4  beta
      REAL*8  acceptance, sum_accept
      REAL*8  sum_energy, sum_enersq, sum_spins, sum_spinsq
      REAL*8  bin_energy, bin_enersq, bin_spins, bin_spinsq
      REAL*8  avbin_spheat, avbin_spheatsq, avbin_susp, avbin_suspsq
      REAL*8  avbin_enersq, avbin_spinsq
      INTEGER therm_sweeps, sweeps, bin_size, num_bins, 
     &        measurements, ibin

      INTEGER spin(0:dimm1, 0:dimm1), new_spin(0:dimm1, 0:dimm1)
      INTEGER oldE(0:dimm1, 0:dimm1), newE(0:dimm1, 0:dimm1)
      INTEGER deltaE(0:dimm1, 0:dimm1)
      INTEGER accept(0:dimm1, 0:dimm1)
      LOGICAL black_white(0:dimm1, 0:dimm1)
      REAL*4  ranum(0:dimm1, 0:dimm1)

      COMMON /values/ spin, ranum, black_white
      COMMON /accpt/  accept, acceptance, sum_accept
      COMMON /params/ beta, therm_sweeps, sweeps, bin_size, num_bins, 
     &                measurements, ibin
      COMMON /sums/   sum_energy, sum_enersq, sum_spins, sum_spinsq
      COMMON /bins/   bin_energy, bin_enersq, bin_spins, bin_spinsq
      COMMON /avgs/   avbin_spheat, avbin_spheatsq, avbin_susp, 
     &                avbin_suspsq
      COMMON /avsq/   avbin_enersq, avbin_spinsq

CMF$ LAYOUT spin(,), new_spin(,)
CMF$ LAYOUT ranum(,), oldE(,), newE(,), deltaE(,)
CMF$ LAYOUT black_white(,), accept(,)


